/*
 * FlyingNum.cpp
 *
 *  Created on: Dec 8, 2013
 *      Author: brian
 */

#include "FlyingNum.h"
#include "InputHandler.h"
#include "Game.h"

#include <vector>

int const FlyingNum::flying_number_layouts[8][7] = {
	    {  0,
	     0,  1,
	       0,
	     0,  1,
	       0},

	    {  1,
	     0,  1,
	       1,
	     1,  0,
	       1},

	    {  1,
	     0,  1,
	       1,
	     0,  1,
	       1},

	    {  0,
	     1,  1,
	       1,
	     0,  1,
	       0},

	    {  1,
	     1,  0,
	       1,
	     0,  1,
	       1},

	    {  1,
	     1,  0,
	       1,
	     1,  1,
	       1},

	    {  1,
	     0,  1,
	       0,
	     0,  1,
	       0},

	    {  1,
	     1,  1,
	       1,
	     1,  1,
	       1}
	  };

FlyingNum::FlyingNum(int digit) {
	//m_direction = 1;
	m_digit = digit -1;
	alive = true;
	scale = 1;
	m_x = 320;
	m_y = 240;
	m_width = 20;
	m_height = 20;
	cout << "FlyingNum Constructor " << endl;

//	for (int i=0; i<7; i++)
//		flying_number_layouts[i] = new int[8];
//
//	flying_number_layouts[0][0] = 0;


}

void FlyingNum::update() {
	if (TheInputHandler::Instance()->isKeyDown(SDL_SCANCODE_SPACE) && alive == false) {
		m_digit = (m_digit + 1) % 8;
		alive = true;
		scale = 1;
		return;
	}
	if (scale > 25) {
		alive = false;
		return;
	}
	if (TheGame::Instance()->getfCount() % 2 == 0)
		scale +=1;

}

void FlyingNum::draw(SDL_Renderer* pRenderer) {

	if (! alive)
		return;
	SDL_Rect dest;
	int i;

	for (i = 0; i < 7; i++) {
		/* If this "light" of the LED is on, then draw it: */

		if (flying_number_layouts[m_digit][i]) {
			/* Determine where the "light" is: */

			if (i == 0 || i == 1 || i == 3 || i == 4 || i == 6)
				dest.x = 320 + (-scale * 5);
			else
				dest.x = 320 + (scale * 5);

			if (i == 0 || i == 1 || i == 2)
				dest.y = 240 + (-scale * 10);
			else if (i == 3 || i == 4 || i == 5)
				dest.y = 240;
			else if (i == 6)
				dest.y = 240 + (scale * 10);

			/* ...And what shape it is: */

			if (i == 0 || i == 3 || i == 6) {
				dest.w = scale * 8;
				dest.h = scale * 2;
			} else {
				dest.w = scale * 2;
				dest.h = scale * 8;
			}

	SDL_SetRenderDrawColor(pRenderer, (rand() % 128) + 128,
									  (rand() % 128) + 128,
									  (rand() % 128) + 128,
									  255);

			//SDL_SetRenderDrawColor(pRenderer, 255, 0, 0, 255);

			//SDL_Rect rectangle;

//	rectangle.x = m_x;
//	rectangle.y = m_y;
//	rectangle.w = m_width;
//	rectangle.h = m_height;
			SDL_RenderFillRect(pRenderer, &dest);
		}
	}

}

void FlyingNum::clean() {
}

